/**
  * Java Service Launcher
*/

//#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
//#include <process.h>
//#include <tchar.h>
#include <winsock.h>
#include "service.h"
#include "java_start.h"

// this event is signalled when the
// service should end
//
HANDLE  hServerStopEvent = NULL;


//
//  FUNCTION: ServiceStart
//
//  PURPOSE: Actual code of the service
//           that does the work.
//
//  PARAMETERS:
//    dwArgc   - number of command line arguments
//    lpszArgv - array of command line arguments
//
//  RETURN VALUE:
//    none
//
//  COMMENTS:
//    The default behavior is to open a
//    named pipe, \\.\pipe\simple, and read
//    from it.  It the modifies the data and
//    writes it back to the pipe.  The service
//    stops when hServerStopEvent is signalled
//
VOID ServiceStart (DWORD dwArgc, LPTSTR *lpszArgv)
{
    //HANDLE                  hEvents[2] = {NULL, NULL};
    //PSECURITY_DESCRIPTOR    pSD = NULL;
	char * arg[] = { "" };

	if ( bDebug )
		logf( "service starting" );

    ///////////////////////////////////////////////////
    //
    // Service initialization
    //    

	if ( bDebug )
		logf( "OK 2" );
    
    // report the status to the service control manager.
    //

	if (!ReportStatusToSCMgr(
		SERVICE_RUNNING,       // service state
		NO_ERROR,              // exit code
		0))                    // wait hint
		return;
		//goto cleanup;
    

    //
    // End of initialization
    //
    ////////////////////////////////////////////////////////

    ////////////////////////////////////////////////////////
    //
    // Service is now running, perform work until shutdown
    //

	if ( bDebug )
		logf( "starting java" );	

	java_start ( dwArgc, lpszArgv  );      
}

//BOOL handlerRoutine(DWORD dwCtrlType) {
//                                                  switch (dwCtrlType) {

//                                                  case CTRL_C_EVENT:
//                                                  case CTRL_CLOSE_EVENT:
//                                                  case CTRL_SHUTDOWN_EVENT:
                                                      // Call method to stop service
                                                     
//                                                      return TRUE;

//                                                  case CTRL_LOGOFF_EVENT:
                                                      // Ignore logoff events.
//                                                      return TRUE;
//                                                  }

                                                  // Let parent handler (the VM) take care of anything else.
//                                                  return FALSE;
//                                              }

//
//  FUNCTION: ServiceStop
//
//  PURPOSE: Stops the service
//
//  PARAMETERS:
//    none
//
//  RETURN VALUE:
//    none
//
//  COMMENTS:
//    If a ServiceStop procedure is going to
//    take longer than 3 seconds to execute,
//    it should spawn a thread to execute the
//    stop code, and return.  Otherwise, the
//    ServiceControlManager will believe that
//    the service has stopped responding.
//    
VOID ServiceStop()
{    
	SOCKADDR_IN sin;
	SOCKET _socket;	

	if ( bDebug )
		logf( "stopping service" );	

	//Connect to the service on the stop port
	_socket = socket(PF_INET, SOCK_STREAM, 0);
	sin.sin_family = AF_INET;
	sin.sin_addr.s_addr = 0x0100007f;
	sin.sin_port = htons ( (short)stopport );
	
	if ( connect (_socket, (LPSOCKADDR) &sin, sizeof (sin)) ) {
		fprintf (stderr, "connect failed: %u\n",  WSAGetLastError  ());
		closesocket (_socket);

	}

}




